using System;
using System.Collections;
using System.ComponentModel;
using System.ComponentModel.Design;
using System.Drawing;
using System.Drawing.Design;
using System.Windows.Forms;
using System.Windows.Forms.Design;
using SAMS.ToolKit.Controls;


namespace SAMS.ToolKit.Design
{
	
	public class ItemListViewDesigner : System.Windows.Forms.Design.ControlDesigner {
		
		
		private void OnComponentRemoving( object sender, ComponentEventArgs e ) {
			IDesignerHost designerHost = (IDesignerHost)GetService( typeof(IDesignerHost) );
			//What is being removed?
			if( e.Component is ImageListView ) {
				//Destory all Items
				ImageListView ilv = (ImageListView)e.Component;
				
				while( ((ImageListView)e.Component).Items.Count > 0 ) {
					designerHost.DestroyComponent( ((ImageListView)e.Component).Items[0] );
					((ImageListView)e.Component).Items.RemoveAt( 0 );
				}
			}
		}
		
		public override void Initialize( IComponent component ) {
			base.Initialize( component );

			IComponentChangeService changeService = (IComponentChangeService)GetService( typeof(IComponentChangeService) );
			changeService.ComponentRemoving += new ComponentEventHandler( OnComponentRemoving );
		}

		protected override void Dispose( bool disposing ) {
			
			IComponentChangeService changeService = (IComponentChangeService)GetService( typeof(IComponentChangeService) );
			changeService.ComponentRemoving -= new ComponentEventHandler( OnComponentRemoving );

			base.Dispose( disposing );
		}

		public ItemListViewDesigner() {
		}
	}
}
