using System;
using System.Drawing;
using System.Drawing.Drawing2D; //TexturedBrush, HatchBrush, LinearGradientBrush
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace BrushDemo
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			this.Paint += new PaintEventHandler( this.OnPaintEventHandler );
			this.SizeChanged += new EventHandler( this.OnSizeChangedEventHandler );

			//Default the brushes
			
		}

		protected void OnSizeChangedEventHandler( object sender, EventArgs e ) {
			this.Invalidate( );
		}

		protected void OnPaintEventHandler( object sender, System.Windows.Forms.PaintEventArgs e ) {
			int width = this.ClientRectangle.Width - 20;
			int height = this.ClientRectangle.Height / 4;
			int top = 0;
			int left = 10;
			int step = height;
			Rectangle rcDisplayRect = new Rectangle( left, top, width, height );
			rcDisplayRect.Inflate(0,-10);
			
			SolidBrush solidBrush = new SolidBrush( System.Drawing.Color.Blue );
			e.Graphics.FillRectangle( solidBrush, rcDisplayRect );
			solidBrush.Dispose( );

			rcDisplayRect.Offset( 0, step );
			HatchBrush hatchBrush = new HatchBrush( HatchStyle.Weave, System.Drawing.Color.Blue, System.Drawing.Color.Gray );
			e.Graphics.FillRectangle( hatchBrush, rcDisplayRect );
			hatchBrush.Dispose( );

			rcDisplayRect.Offset( 0, step );
			LinearGradientBrush lgb = new LinearGradientBrush( rcDisplayRect, 
				                                               System.Drawing.Color.Black, 
				                                               System.Drawing.Color.White, 
				                                               45f );
			e.Graphics.FillRectangle( lgb, rcDisplayRect );
			lgb.Dispose( );

			
			rcDisplayRect.Offset( 0, step );
			System.Drawing.Image samsImage = Image.FromFile( "sams.jpg" );
			TextureBrush tb = new TextureBrush( samsImage );
			e.Graphics.FillRectangle( tb, rcDisplayRect );
			
			samsImage.Dispose( );
			
			tb.Dispose( );
			
			
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackColor = System.Drawing.SystemColors.Window;
			this.ClientSize = new System.Drawing.Size(528, 517);
			this.Name = "Form1";
			this.Text = "GDI+ Brush Demo";

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}
	}
}
