using System;
using System.Drawing;
using System.Drawing.Imaging;

namespace ImageStudio
{
	public class ImageDocument
	{
		
		private Image	image;

		public event EventHandler DocumentChanged;

		public Image Image {
			get { return image; }
		}

		public ImageDocument()	{		}

		public bool Open( string FileName ) {
			try {
				image = Image.FromFile( FileName );
				OnDocumentChanged( new EventArgs( ) );
				return true;
			} catch( Exception e ) {
				System.Diagnostics.Debug.WriteLine( e.Message );
				return false;
			}
		}

		public bool Save( string Filename, ImageFormat Format ) {
			try {
				image.Save( Filename, Format );
				return true;
			} catch( Exception e ) {
				System.Diagnostics.Debug.WriteLine( e.Message );
				return false;
			}
		}

		protected virtual void OnDocumentChanged( EventArgs e ) {
			if( DocumentChanged != null )
				DocumentChanged( this, e );
		}
	}
}
