using System;
using System.Windows.Forms;
using System.Drawing;
using System.Drawing.Imaging;


namespace ImageStudio
{

	public class ImageView : System.Windows.Forms.Panel
	{
		private ImageDocument	imageDocument;

		public ImageView( ImageDocument Document )
		{
			this.BorderStyle = BorderStyle.Fixed3D;
			imageDocument = Document;
			if( imageDocument.Image != null )
				AutoScrollMinSize = imageDocument.Image.Size;
			
		}

		protected override void OnSizeChanged( EventArgs e ) {
			base.OnSizeChanged( e );
			this.Invalidate( );
		}
		
		protected override void OnPaint( PaintEventArgs e ) {
			base.OnPaint( e );
			if( imageDocument.Image != null )
				e.Graphics.DrawImage( imageDocument.Image, 
					                  AutoScrollPosition.X, AutoScrollPosition.Y, 
					                  imageDocument.Image.Width, imageDocument.Image.Height );
		}
	}
}
