using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Drawing.Imaging;

namespace ImageStudio
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class MainFrame : System.Windows.Forms.Form
	{
		private System.Windows.Forms.MainMenu mainFrameMenu;
		private System.Windows.Forms.MenuItem fileOpenMenuItem;
		private System.Windows.Forms.MenuItem fileCloseMenuItem;
		private System.Windows.Forms.MenuItem fileSaveAsMenuItem;
		private System.Windows.Forms.MenuItem fileExitMenuItem;
		private System.Windows.Forms.MdiClient mdiClient1;
		private System.Windows.Forms.MenuItem fileSep2MenuItem;
		private System.Windows.Forms.MenuItem fileSep1MenuItem;
		private System.Windows.Forms.MenuItem fileMenuItem;
		private System.Windows.Forms.OpenFileDialog openFileDialog;
		private System.Windows.Forms.SaveFileDialog saveFileDialog;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem windowMenuItem;


		private ArrayList						fileFormats;

		public MainFrame()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			fileFormats = new ArrayList( );
			fileFormats.Add( ImageFormat.Bmp );
			fileFormats.Add( ImageFormat.Gif );
			fileFormats.Add( ImageFormat.Jpeg );
			fileFormats.Add( ImageFormat.Png );
			fileFormats.Add( ImageFormat.Tiff );
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.openFileDialog = new System.Windows.Forms.OpenFileDialog();
			this.fileExitMenuItem = new System.Windows.Forms.MenuItem();
			this.mdiClient1 = new System.Windows.Forms.MdiClient();
			this.saveFileDialog = new System.Windows.Forms.SaveFileDialog();
			this.fileSep1MenuItem = new System.Windows.Forms.MenuItem();
			this.fileSep2MenuItem = new System.Windows.Forms.MenuItem();
			this.fileOpenMenuItem = new System.Windows.Forms.MenuItem();
			this.fileCloseMenuItem = new System.Windows.Forms.MenuItem();
			this.mainFrameMenu = new System.Windows.Forms.MainMenu();
			this.fileMenuItem = new System.Windows.Forms.MenuItem();
			this.fileSaveAsMenuItem = new System.Windows.Forms.MenuItem();
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.windowMenuItem = new System.Windows.Forms.MenuItem();
			this.SuspendLayout();
			// 
			// openFileDialog
			// 
			this.openFileDialog.DefaultExt = "bmp";
			this.openFileDialog.Filter = "Bitmaps|*.bmp|Gif|*.gif|Jpeg|*.jpg|Tiff|*.tiff|Png|*.png";
			this.openFileDialog.Title = "Open Image File";
			// 
			// fileExitMenuItem
			// 
			this.fileExitMenuItem.Index = 5;
			this.fileExitMenuItem.Text = "E&xit";
			this.fileExitMenuItem.Click += new System.EventHandler(this.fileExitMenuItem_Click);
			// 
			// mdiClient1
			// 
			this.mdiClient1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.mdiClient1.Name = "mdiClient1";
			this.mdiClient1.TabIndex = 0;
			// 
			// saveFileDialog
			// 
			this.saveFileDialog.FileName = "image";
			this.saveFileDialog.Filter = "Bitmaps|*.bmp|Gif|*.gif|Jpeg|*.jpg|Tiff|*.tiff|Png|*.png";
			// 
			// fileSep1MenuItem
			// 
			this.fileSep1MenuItem.Index = 2;
			this.fileSep1MenuItem.Text = "-";
			// 
			// fileSep2MenuItem
			// 
			this.fileSep2MenuItem.Index = 4;
			this.fileSep2MenuItem.Text = "-";
			// 
			// fileOpenMenuItem
			// 
			this.fileOpenMenuItem.Index = 0;
			this.fileOpenMenuItem.Text = "&Open";
			this.fileOpenMenuItem.Click += new System.EventHandler(this.fileOpenMenuItem_Click);
			// 
			// fileCloseMenuItem
			// 
			this.fileCloseMenuItem.Index = 1;
			this.fileCloseMenuItem.Text = "&Close";
			this.fileCloseMenuItem.Click += new System.EventHandler(this.fileCloseMenuItem_Click);
			// 
			// mainFrameMenu
			// 
			this.mainFrameMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																						  this.fileMenuItem,
																						  this.windowMenuItem});
			// 
			// fileMenuItem
			// 
			this.fileMenuItem.Index = 0;
			this.fileMenuItem.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																						 this.fileOpenMenuItem,
																						 this.fileCloseMenuItem,
																						 this.fileSep1MenuItem,
																						 this.fileSaveAsMenuItem,
																						 this.fileSep2MenuItem,
																						 this.fileExitMenuItem});
			this.fileMenuItem.Text = "&File";
			// 
			// fileSaveAsMenuItem
			// 
			this.fileSaveAsMenuItem.Index = 3;
			this.fileSaveAsMenuItem.Text = "Save &As...";
			this.fileSaveAsMenuItem.Click += new System.EventHandler(this.fileSaveAsMenuItem_Click);
			// 
			// windowMenuItem
			// 
			this.windowMenuItem.Index = 1;
			this.windowMenuItem.MdiList = true;
			this.windowMenuItem.Text = "Window";
			// 
			// MainFrame
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(592, 393);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.mdiClient1});
			this.IsMdiContainer = true;
			this.Menu = this.mainFrameMenu;
			this.Name = "MainFrame";
			this.Text = "ImageStudio";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new MainFrame());
		}


		//////////////////////////////
		///File Menu Event Handlers
		//////////////////////////////
		
		private void fileOpenMenuItem_Click(object sender, System.EventArgs e) {
			
			if( DialogResult.OK == openFileDialog.ShowDialog( ) ) {
				ImageDocument doc = new ImageDocument( );
				if( doc.Open( openFileDialog.FileName ) ) {
					ImageFrameChild child = new ImageFrameChild( doc );
					//child.TopLevel = false;
					string[] T = openFileDialog.FileName.Split( '\\' );
					child.Text = T[T.Length-1];
					child.MdiParent = this;
					child.Show( );
				}
			}
			
		}

		private void fileCloseMenuItem_Click(object sender, System.EventArgs e) {
			this.ActiveMdiChild.Close( );
		}
		
		private void fileSaveAsMenuItem_Click(object sender, System.EventArgs e) {
			if( DialogResult.OK == saveFileDialog.ShowDialog( ) ) {
				ImageDocument doc = ((ImageFrameChild)ActiveMdiChild).Document;
				doc.Save( saveFileDialog.FileName, GetImageFormat( saveFileDialog.FilterIndex - 1) );
			}
		}

		private void fileExitMenuItem_Click(object sender, System.EventArgs e) {
			Close( );
		}

		private ImageFormat GetImageFormat( int FilterIndex ) {
			return (ImageFormat)fileFormats[ FilterIndex ];
		}
	}
}
