using System;

namespace CustomEvents
{


	public class MyCustomEventArgs : System.EventArgs {

		private string	msg;

		public string Message {
			get { return msg; }
		}


		public MyCustomEventArgs( string Message ) {
			msg = Message;
		}
	}

	public delegate void MyCustomEventHandler( object sender, MyCustomEventArgs e );


	public class MyControl {

		public event MyCustomEventHandler	CustomEvent;


		public void RaiseEvent( string Message ) {
			OnMyCustomEvent( new MyCustomEventArgs( Message ) );
		}

		protected virtual void OnMyCustomEvent( MyCustomEventArgs e ) {
			if( CustomEvent != null )
				CustomEvent( this, e );
		}

	}




	public class EventTest {

		public static void OnMyControl_CustomEvent( object sender, MyCustomEventArgs e ) {
			Console.WriteLine( string.Format( "Caught custom event : {0}", e.Message ) );
		}

		public static void Main( ) {

			MyControl ctrl = new MyControl( );

			ctrl.CustomEvent += new MyCustomEventHandler( EventTest.OnMyControl_CustomEvent );

			ctrl.RaiseEvent( "Raising Event" );
		}
	}

}
